/* CA utility: unload the database  */

#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <time.h>

#include "db.h"

char *fixreq(char *reqi)
{
  static char reqo[16384];
  char *p=reqo;

  while (*reqi) {
     if (*reqi!='\r') *p++ = *reqi;
     reqi++;
  }
  *p = '\0';
  return (reqo);
}

/* includes the quotes */
char *fixdate(time_t in)
{
  static char dat[24];
  struct tm *t = localtime(&in);
  if (in==0) {
     return("\\N");
  }
  sprintf(dat, "'%04d-%02d-%02d'", t->tm_year+1900, t->tm_mon+1, t->tm_mday);
  return (dat);
}
  
char *fixnote(char *in)
{
  static char out[1024];
  char *p=out;
  while (*in) {
     if (*in=='\'') *p++ = '\\';
     *p++ = *in++;
  }
  *p = '\0';
  return (out);
}
  

main(int argc, char **argv)
{
   SvrReq R = (SvrReq) malloc(sizeof(SvrReq_));
   SvrCert S = (SvrCert) malloc(sizeof(SvrCert_));
   SvrNotes N = (SvrNotes) malloc(sizeof(SvrNotes_));
   int mxsn = 0;

   db_connect();

   db_select_req(0,NULL, 0,0,0);

   while (db_get_req(R)>0) {
      char *rd = fixdate(R->request_date);
      char crttxt[24];
      if (R->crtno) sprintf(crttxt,"'%d'", R->crtno);
      else strcpy(crttxt, "\\N");
      printf("insert into svreq values ("
            "%d,'%s',%d,%s,%s,'%s','%s',%d);\n",
        R->reqno, R->reqid, R->status, rd, crttxt, 
        fixreq(R->request), R->dn, R->hash);
      db_select_notes(R->reqno);
      while (db_get_notes(N)>0) {
         printf("insert into svnot values ("
               "%d,%d,'%s');\n",
           N->notno, N->reqno, fixnote(N->notes));
      }
      db_free_notes();
   }
 

   db_select_crt(0,0,0);

   while (db_get_crt(S)>0) {
      char *id = strdup(fixdate(S->issue_date));
      char *ed = strdup(fixdate(S->expire_date));
      char *rd = strdup(fixdate(S->revoke_date));
      printf("insert into svcrt values ("
            "%d,%d,%d,%d,'%s',%s,'%s',%s,'%s',%s,%d);\n",
        S->crtno, S->reqno, S->casn, S->status, fixreq(S->cert),
        id, S->issue_by, rd, S->revoke_by, ed, S->expno);
      free(id);
      free(ed);
      free(rd);
   }
}

