#include "mgoapi.h"

/* Verify the crn info for this user.
   crn may contain both a crn string as well as the prn text. (crn=prn)
   Return 0 if OK, else return MGOerrno. */

int crn_verify(char *id, char *crnprn)
{
   char *crns;
   char *eq;
   int prn;
   int crnl = 0;
   char tok[65], cab[65], crn[65];
   int pos = 0;
   int s;
   
   s = MGOconnect();
   if (s<1) return (MGOerrno);
  
   s = MGOgetcrn(&crns, id);
   if (s<1) return (MGOerrno);

   /* get the appropriate card from the input crn */
   eq = strchr(crnprn, '=');
   if (eq) {
      crnl = eq - crnprn;
      if (crnl>=sizeof(cab)) crnl = sizeof(cab);
      strncpy(cab, crnprn, crnl);
      cab[crnl-1] = '\0';
      prn = atoi(eq+1);
   } else {
      prn = atoi(crnprn);
     
   }
   
   while ((s=MGOparse(crns, &pos, tok, sizeof (tok), 0)) > 0) {
      if (crnl && !strstr(tok,cab))  continue;
      if (MGOvalue (tok, crn, sizeof (crn), 0) < 1) {
          MGOkeyname (tok, crn, sizeof (crn), 0);
      }
      break;
   }

   if (s>0) s = MGOsidcheck(id, crn, prn, 0);
   
   MGOfreechar (&crns);
   MGOdisconnect ();

   if (s<1) return (MGOerrno);
  
   return (0);
}


#ifdef MAIN
int main(int argc, char *argv[])
{
   char *id=argv[1];
   char *crn=argv[2];
   int s;
   
   s = crn_verify(id, crn);
   if (s==0) printf("OK\n");
   else printf("err=%d, msg=%s\n", s, MGOerrmsg);
}
#endif
