<!-- UW Services CA CPS text -->


<h5><i>Draft, April 7, 2003</i></h5>
<p>

Contents

<p>

<table cellspacing=0 border=0>
<tr><td>1-</td><td><a href=#intro>Introduction</td>
    <td width=20></td>
    <td>4-</td><td><a href=#adm>Admendment</td>
<tr><td>2-</td><td><a href=#svc>Infrastructure</td>
    <td></td>
    <td>5-</td><td><a href=#inf>Contact Information</td>
<tr><td>3-</td><td><a href=#req>Customer Requirements</td>
    <td></td>
    <td>6-</td><td><a href=#dis>Disclaimer</td>
</table>




<!-- CPS body text -->

<p>
<h3>1. <a name=intro>Introduction</h3>
<p>

A Certificate Authority (CA) is maintained by
the University of Washington (UW)
to facilitate secure communincation between clients and
services at the University of Washington by
issuing IETF X509 client and server certificates 
to authorized applications.

These certificates allow the applications to positively
identify themselves and authenticate their peers
in a communications network.

<p>

This CPS decribes the policies in place for the CA 
identified by the following certificates:
<p>
<table class=indent border=2 cellpadding=2>
<tr>
 <td>Common Name</td><td>Fingerprint</td>
</tr>
<tr>
 <td align=top>UW Services CA</td>
 <td><table border=0 cellpadding=2>
  <tr><td>MD5</td><td>04:41:05:F2:32:5D:25:2C:00:97:46:C2:FE:00:17:51</td></tr>
  <tr><td>SHA1</td><td>B9:76:8F:DA:34:54:56:46:9A:0B:AE:38:64:FE:00:55:C9:E6:35:7F</td></tr>
  </table></td>
</tr>
<tr><td colspan=2><i>others may be added</i></td></tr>
</table>

<p>

It is expected that a majority of the University 
community will install the <b>UW Services CA</b> certificate into their
browsers or email clients as a trusted certificate authority,
thereby allowing UW issued certificates to seamlessly and
securely authenticate UW web and email applications. 

<p>
<h4>Intended Use</h4>
Certificates issued by the CA may be used only by
authorized administrators of services provided by
the University of Washington.
They may be used to identify web servers and imap
servers to their clients.  They may also be used
to identify each peer of an application to application
communincation.  


<p>
<h3>2. <a name=svc>Infrastructure</h3>
<p>

The CA maintains one or more secure root certificates
along with: tools to
securely sign, renew, and revoke certificate requests;
a database of issued 
certificates; a list of revoked certificates; and a log
of activity.
 
<p>

<h4>CA Root Certificate</h4>

<p>
<dl>
<dt>&nbsp&nbsp Certificate
<dd>The "<b>UW Services CA</b>" certificate is 
available for installation
into any browser or application. 
<p>
<dt>&nbsp&nbsp Key
<dd>The root certificate key is maintained on a secure system
housed in a locked area of the University of Washington's
computing facility
and is assessable only through remote procedures by 
CA administrators and other authorized
personnel for issuance and revocation of certificates and creation of
Certificate Revocation Lists (CRL).

</dl>
<p>

<h4>Certificate Issuance and Renewal</h4>
<p>
<ol>
<li>Requests for certificates are recieved via authenticated
web transactions
and entered into a database.  
A request consists of the applicant's identity (<b>UWNetId</b>,
as provided by WebLogin);
the intended purpose of the certificate, client, server, or both;
the request itself (CR)
in PEM format; and commentary notes. 
Requests for renewal
will not include the CR text. Only the certificate owner
may request its renewal. 
<p>
<li>An administrator retrieves an active request from the database,
verifies its identity and application, and, if
acceptable, updates the database with a signed certificate.
<p>
<li>The applicant retrives the signed certificate from 
the CA's web service.
<p>
<li>Reasons for refusal of a request are logged and are
provided to the requestor.
</ol>
<p>

<p>

<h4>Certificate Lifetime and Content</h4>
<p>
Certificates issued by the CA contain:
<br>
<ul>
 <li>Subject:
     <ol>
     <li>C=US, ST=WA
     <li>O and OU fields are optional
     <li>CN=<i>domain name of the service</i>
     </ol>
 <li>Validity:
     <ol>
     <li>Not Before: The date of issuance
     <li>Not After: One year from the date of issuance
     </ol>
 <li>X509v3 extensions:
     <ol>
     <li>X509v3 Basic Constraints: CA:FALSE
     </ol>
</ul>
<p>

<h4>Certificate Revocation</h4>

Certification revocation is also by authenticated web transaction,
and may be instigated only by the certificate holder. 
The CA maintains a 
publcally avialable Certificate Revocation List (CRL)
for each root certificate.

<p>
<h4>Transaction Logs</h4>
<p>
The CA maintains logs of all transactions.


<p>
<h3>3. <a name=req>Customer Requirements</h3>
<p>

Certificates are available only for authorized services of the
University.  Application administrators are requesting one
or more certificates are expected to:
<p>
<ul>
<li>Be able to securely generate a certificate request, and
store and use the resultant certificate and key;
<li>Be aware that clients of the application will have to
load or install the UW Server CA certificate as a trusted
certificate authority in their programs, and be willing
to assist them in that effort;
<li>Inform their clients of the existance and use of the
CA's Certificate Revocation List;
<li>Notify us if either the certificate or
its key has been compriomised; and
<li>Notify us if any change occurs in the ownership of
the serivce to which the certificate applies.
</ul>
<p>


<p>
<h3>4. <a name=adm>Amendment</h3>
<p>

UW reserves the right to modify the services of this CA,
including, but not limited to:
<p>
<ul>
<li>Issuance of client certificates for personal identification,
<li>Creation of additions root certificates for special circumstances
not covered by the present CAs.
</ul>

<p>
Additions to service will be accompanied by corresponding
documentation in this CPS.  Current certificate holders
will be notified by email to the certificate owner
prior to any modifications which may adversley affect
their applications.

<p>


<p>
<h3>5. <a name=inf>Contact Information</h3>
<p>

Send inquiries to
<a href=mailto:help@u.washington.edu>
Help@u.washington.edu</a>.

<br>
See also:
the <a href="http://www.washington.edu/computing/">
 Computing and Computing home page</a>
and the
<a href="http://www.washington.edu/">University of Washington home page</a>

<p>
<h3>6. <a name=dis>Disclaimer</h3>
<p>

THE UNIVERSITY OF WASHINGTON MAKES NO REPRESENTATIONS OR WARRANTIES,
EXPRESS OR IMPLIED, WITH RESPECT TO THESE SERVICES,
INCLUDING ANY WARRANTIES OF TITLE,
NONINFRINGEMENT OF COPYRIGHT OR PATENT RIGHTS OF OTHERS,
MERCHANTABILITY, OR FITNESS OR SUITABILITY FOR ANY PURPOSE.

