/* CA main page */

#include <stdio.h>
#include <signal.h>

#include "webtpl.h"
#include "db.h"
#include "util.h"
#include "cassl.h"

extern char *remote_user;
extern int errno;
char *errstr = NULL;

#define REQ(s) (req && !strcmp(req,s))

/* handle client disconnect */

void catch_pipe(int a)
{
   signal(SIGPIPE, catch_pipe);
}

main()
{
  WebTemplate W = newWebTemplate();
  char *userid;
  char *req;
  char *seqstr;
  int seq = 0;
  int s;
  char *xseq;
 
  signal(SIGPIPE, catch_pipe);

  WebTemplate_set_comments(W, "#", NULL);
  WebTemplate_get_by_name(W, "page", "page.tpl");

  /* Get arguments */

  WebTemplate_get_args(W);

  userid = remote_user;
  seqstr = WebTemplate_get_arg(W, "seq");
  if (seqstr) seq = atoi(seqstr);
  req = WebTemplate_get_arg(W, "req");
  xseq = WebTemplate_get_arg(W, "req");

  WebTemplate_assign(W, "TITLE",
             "University of Washington Certificate Authority");
  WebTemplate_assign(W, "CURPAGE", "UW CA home");
  WebTemplate_assign(W, "ROOT", URLROOT);

  xsec_set_valid_form(W);


  /* rest of page depends on request */

  /* send the 'services:about' page */

  if (REQ("svabt")) {

     crumb_init(W);
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Purpose");
     WebTemplate_get_by_name(W, "about", "about.tpl");
     WebTemplate_parse(W, "BODY", "about");


  /* send the 'cps' page */

  } else if (REQ("cps")) {

     crumb_init(W);
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Certificate Practices Statement");
     WebTemplate_get_by_name(W, "cps", "cps.tpl");
     WebTemplate_parse(W, "BODY", "cps");

 
  /* send the 'help' page */

  } else if (REQ("help")) {

     crumb_init(W);
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Help");
     WebTemplate_get_by_name(W, "help", "help.tpl");
     WebTemplate_parse(W, "BODY", "help");

 
  /* send SV CA cert as pem text */

  } else if (REQ("svpem")) {

     char *pem;
     char *pemfile = (char*) malloc(strlen(DIRROOT)+64);
     int nc, nr;

     crumb_init(W);
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "CA root certificate");
     WebTemplate_get_by_name(W, "ptop", "capem_top.tpl");
     WebTemplate_get_by_name(W, "pbody", "pem_body.tpl");
     sprintf(pemfile, "%s/services/certs/cacert.pem", DIRROOT);
     pem = get_file(pemfile, NULL);
     free(pemfile);
     WebTemplate_assign(W, "PEM", pem);
     WebTemplate_parse(W, "TOPBODY", "ptop");
     WebTemplate_parse(W, "BODY", "pbody");
    
     crumb_help(W, "?req=pemh");

  /* send PEM helptext */

  } else if (REQ("pemh")) {

     crumb_init(W);
     add_crumb(W, "?req=svpem", "CA Root");
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Working with a root certificate");
     WebTemplate_get_by_name(W, "help", "help_root.tpl");
     WebTemplate_parse(W, "BODY", "help");


  /* send SV CA cert as der */

  } else if (REQ("svder")) {

     char *der;
     char *derfile = (char*) malloc(strlen(DIRROOT)+64);
     int l;
     char *hdr = "Content-type: application/pkix-cert\n\n";

     sprintf(derfile, "%s/services/certs/cacert.der", DIRROOT);
     der = get_file(derfile, &l);
     free(derfile);
     write(1, hdr, strlen(hdr));
     write(1, der, l);
     exit (0);

  /* send CRL as pem text */

  } else if (REQ("crl")) {

     char *pem;
     char *pemfile = (char*) malloc(strlen(DIRROOT)+64);

     crumb_init(W);
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Certificate Revocation List");
     WebTemplate_get_by_name(W, "crl", "crl.tpl");
     WebTemplate_get_by_name(W, "pembody", "pem_body.tpl");
     sprintf(pemfile, "%s/services/certs/crl.pem", DIRROOT);
     pem = get_file(pemfile, NULL);
     free(pemfile);
     WebTemplate_assign(W, "PEM", pem);
     WebTemplate_parse(W, "TOPBODY", "crl");
     WebTemplate_parse(W, "BODY", "pembody");

     crumb_help(W, "?req=crlh");
  

  /* send CRL helptext */

  } else if (REQ("crlh")) {

     crumb_init(W);
     add_crumb(W, "?req=crl", "CRL");
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Working with the CRL");
     WebTemplate_get_by_name(W, "help", "help_crl.tpl");
     WebTemplate_parse(W, "BODY", "help");


  /* send stats */

  } else if (REQ("stats")) {

     crumb_init(W);
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "PAGETITLE", "Statistics");
     WebTemplate_get_by_name(W, "top", "stats/sum.html");
     WebTemplate_get_by_name(W, "body", "stats_body.tpl");
     WebTemplate_parse(W, "TOPBODY", "top");
     WebTemplate_parse(W, "BODY", "body");
  

  /* send a permission denied page */

  } else if (REQ("nop")) {

     char *uri = getenv("REQUEST_URI");

     crumb_init(W);
     WebTemplate_assign(W, "CA", "");
     WebTemplate_assign(W, "PAGETITLE", "No permission");
     if (uri && *uri && strstr(uri,"admin")) {
        WebTemplate_get_by_name(W, "top", "nop_adm.tpl");
     } else {
        WebTemplate_get_by_name(W, "top", "nop_req.tpl");
     }
     WebTemplate_parse(W, "TOPBODY", "top");

  /* Send the main page */

  } else {

     WebTemplate_get_by_name(W, "top", "homepage.tpl");
     WebTemplate_parse(W, "TOPBODY", "top");
  }
 
  WebTemplate_parse(W, "PAGE", "page");
  WebTemplate_write(W, "PAGE");

}

