/* CA utility: test domain */

#include <stdio.h>
#include <signal.h>
#include <string.h>

extern char *remote_user;
extern int errno;
char *errstr = NULL;



char **netact_get_host_ids(char *name);
char **netact_get_domain_ids(char *name);

char *ssl_chk_dns();

main(int argc, char **argv)
{
  char *arg;
  char *dn;
  char *rsp;
  char **list;
  char *dp,*edp;
  char *id = NULL;

  if (argc==2) {
     dn = argv[1];
  } else if (argc==3) {
     dn = argv[1];
     id = argv[2];
  } else {
     fprintf(stderr,"usage: %s dns_name\n", argv[0]);
     exit (1);
  }

  if (id) {
     rsp = ssl_chk_netacts(dn, strlen(dn), id);
     if (rsp) printf(" %s\n", rsp);
     else printf(" %s is OK for %s\n", id, dn);
     exit (0);
  }

  if (dn && *dn) {
  
     /* show dns */

     rsp = ssl_chk_dns(dn, 0);
     if (!rsp) printf("dns: OK\n");
     else printf("dns: %s\n", rsp);
    
     /* show host */

     list = netact_get_host_ids(dn);
     if (list && *list) {
        while (*list) {
           printf("host: %s owned by %s\n", dn, *list);
           list++;
        }
     }
    

     /* Show subdomains */

     if (edp=strstr(dn,".washington.edu")) {
        for (dp=strchr(dn,'.');dp&&dp<edp;dp=strchr(dp+1,'.')) {
          list = netact_get_domain_ids(dp+1);
          if (list && *list) {
            while (*list) {
              printf("subdomain: %s owned by %s\n", dp+1, *list);
              list++;
            }
          }
        }
     }
  }
           
}

