/* CA utility: regenerate the server's (Signer's) cert database */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>

#include "db.h"

main(int argc, char **argv)
{
   SvrReq R = (SvrReq) malloc(sizeof(SvrReq_));
   SvrCert S = (SvrCert) malloc(sizeof(SvrCert_));
   int mxsn = 0;

   if (!db_connect()) {
      printf("DBconn: %s\n", db_last_error());
      exit (1);
   }

   if (!db_select_req(0,NULL, 0,0,0)) {
      printf("DBsel: %s\n", db_last_error());
      exit (1);
   }

   while (db_get_req(R)>0) {
      if (!R->crtno) continue;

      db_select_crt(R->crtno, 0, 0);
      while (db_get_crt(S)>0) {
         printf("%x %u %u %u %s\n", S->casn, S->issue_date,
                 S->expire_date, S->revoke_date, R->dn);
         if (S->casn>mxsn) mxsn = S->casn;
      }
      db_free_crt();
   }
 
   fprintf(stderr,"Next serial number = %x\n", mxsn+1);

}

