/* test ownership of a host or domain */

#include <stdio.h>
#include "soapH.h"
#include "netact.h"

char *prog;

usage()
{
  fprintf(stderr,"usage: %s [-u userid] host|domain\n", prog);
  exit (1);
}
  
main(int argc, char **argv)
{
  char *ip = NULL;
  char *id = NULL;
  char **list;
  char *edp, *dp;
  int chk_dom = 1;

  prog = argv[0];
  while (--argc>0) {
     argv++;
     if (!strcmp(argv[0],"-u")) {
        if (--argc<0) usage();
        argv++;
        id=argv[0];
     } else if (!strcmp(argv[0],"+d")) chk_dom = 0;
     else if (argv[0][0]!='-') ip = argv[0];
  }
  if (!ip) usage();

  /* either test an id or list owners */

  if (id) {

     if (netact_test_name(ip, id)) printf("OK, %s owns %s\n", id, ip);
     else printf("NO, %s does not own %s\n", id, ip);

  } else {

     /* check host */
     list = netact_get_host_ids(ip);
     if (list) {
        printf("Host %s owned by:\n", ip);
        while (*list) {
           printf("  \'%s\' (%d)\n", *list, strlen(*list));
           list++;
        }
     } else printf("Host %s not in database\n", ip);

     /* check domains */

     if (!chk_dom) exit (0);
     if (!(edp=strrchr(ip,'.'))) exit (0);
     if (!(edp=strrchr(edp-1,'.'))) exit (0);

     for (dp=ip;dp&&dp<edp;dp=strchr(dp,'.')+1) {
       list = netact_get_domain_ids(dp);
       if (list) {
          printf("Domain %s owned by:\n", dp);
          while (*list) {
             printf("  %s\n", *list);
             list++;
          }
       } else printf("Domain %s not in database\n", dp);
     }
  }

}


