
<!-- form for msie cert renewal -->


<SCRIPT type="text/vbscript">

 ' Option Explicit

' recover cert properties from the cert being renewed

Dim cert_dn

Function setRenewFlags(sn)
  On Error Resume Next

  sn = UCase(sn)
  If Len(sn) < 4 Then
    sn = "0" & sn
  End If
  ' MsgBox("Looking for sn =" & sn)
  foundCert = false

  set store = CreateObject("Capicom.Store")

  ' If no capicom we get no createobject
  ' If they say no to access to cert store we get blank cert
  If IsObject(store) Then
     store.Open 1, "My", 128
     For Each cert in store.Certificates 
        ' MsgBox("Cert: " & cert.getInfo(0) & " issuer=" & cert.getInfo(1) & " sn=" & cert.SerialNumber)
        If cert.SerialNumber = sn Then
           xenroll.ProviderName = cert.PrivateKey.ProviderName
           xenroll.ContainerName = cert.PrivateKey.ContainerName
           xenroll.ProviderType = cert.PrivateKey.ProviderType
           xenroll.KeySpec = cert.PrivateKey.KeySpec
           cert_dn = cert.SubjectName
           If Len(cert_dn) > 2 Then
              foundCert = true
              ' MsgBox("Found it. DN=" & cert_dn)
           End If
           Exit For
        End If
     Next

     If foundCert Then
        setRenewFlags = 0
     Else
        MsgBox("Certificate " & sn & " not found!")
        document.all.nofind.style.visibility = "visible"
        setRenewFlags = 1
     End IF

  Else 
      ' MsgBox("Unable to load Capicom!")
      document.all.nocapicom.style.visibility = "visible"
      setRenewFlags = 1
  End If

End Function


' create the request - key attributes already chosen

Function CreatePKCS10Request(cn)
  Const AT_KEYEXCHANGE = 1
  Const AT_SIGNATURE = 2

   If document.certform.storetype.value = "local-machine" Then
     xenroll.RequestStoreFlags = &H20000
     document.requestData.storeflags.value = "&H20000"
   Else
     xenroll.RequestStoreFlags = &H10000
     document.requestData.storeflags.value = "&H10000"
   End If

  xenroll.EnableT61DNEncoding=True
  xenroll.UseExistingKeySet = True
  CreatePKCS10Request = xenroll.createPKCS10(cert_dn, "")
End Function


' button action to request the cert

sub CertRequestSub
  Dim cn
  Dim dn
  Dim notes
  cn = document.certform.cn.value
  document.requestData.reqtxt.value = CreatePKCS10Request(cn)
  ' MsgBox("Req: "  & document.requestData.reqtxt.value)
  document.requestData.action.value = "submit"
  document.requestData.submit()
end sub




Function activateSubmit()

  document.certform.request.disabled = false 

End Function

' on load, lookup the cert to renew

Sub postLoad()
  ' On Error Resume Next
  Dim n  
  n = 1
  ' lookup the existign cert
  n = setRenewFlags("{CASN}")
  if n <> 0 Then
    Exit Sub 
  end if 
  ' activateSubmit()
  ' just do the submit
  CertRequestSub()
End Sub


</SCRIPT>




<!-- This is the form that actually get submitted -->

<form name="requestData" action="{ROOT}/services/" method=post>

<input type="hidden" name="reqtxt">
<input type="hidden" name="action" value="">
<input type="hidden" name="storeflags" value="">
  <input type=hidden name=xsite value={XSITE}>
  <input type=hidden name=xtime value={XTIME}>
<input type="hidden" name="req" value="sub">
<input type="hidden" name="form4ms" value="yes">
<input type="hidden" name="renew" value="{REQNO}">

</form>


<!-- this visible form is processed by "CertRequestSub" -->

<form name="certform">

<input type="hidden" name="storeflags" value="">
<input type=hidden name=storetype value="local-machine">
<input type="hidden" name="protectkey" value="" >
<input type="hidden" name="sn" value="{CASN}" >
<input type="hidden" name="cn" value="{CN}" >

<p>

Renew {CN}, serial number 0x{CASN}?

<p>
<input type="button" name="request" value="Renew the certificate"
       onClick="CertRequestSub" language="VBSCRIPT" 
       border=0 disabled>

</form>
<p>
<!-- show this if no capicom found -->
<div id="nocapicom"
 style="margin:1em; margin-right:4em; padding:1em; border-color:black; border-width:1; border-style:groove; visibility: hidden;">
<h3>Could not find capicom</h3>
<p> 
You must install <b>CAPICOM 2.0</b> prior to 
attempting to renew a certificate.  See MSDN's 
<a href=http://windowssdk.msdn.microsoft.com/en-us/library/ms759176.aspx>CAPICOM installation</a> page
for instructions.
</div>

<!-- show this if no cert found -->
<div id="nofind"
 style="margin:1em; margin-right:4em; padding:1em; border-color:black; border-width:1; border-style:groove; visibility: hidden;">
<h3>Could not find certificate 0x{CASN}</h3>
<p> 
The certificate you are attempting to renew (cn=<tt>{CN}</tt>, sn=0x{CASN}) could
not be found.  Possibly its private key has been deleted.
<p>
You may request a new certificate to avoid this problem.
</div>


