/* cert requestor and loader for IE */

#include <stdio.h>
#include <time.h>
#include <string.h>

#include "webtpl.h"
#include "util.h"
#include "db.h"

extern char *remote_user;
extern int errno;

static char *DB2_ENV = "DB2INSTANCE=db2inst1";


#define REQ(s) (req && !strcmp(req,s))

char *fix_cert_for_vbs(char *crt)
{
   char *fix = (char*)malloc(strlen(crt)+1024);
   char *p = fix;
   char *cp;
   for (cp=crt;cp;) {
     *p++ = '"';
     cp = strchr(crt,'\n');
     if (cp) *cp++ = '\0';
     while (*crt) *p++ = *crt++;
     strcpy(p, "\" & _\n");
     p += 6;
     *p = '\0';
     crt = cp;
     if (!*cp) break;
   }
   p -= 5;
   *p = '\0';
   return (fix);
}

main()
{
  WebTemplate W = newWebTemplate();
  char *userid;
  char *req;
  char *seqstr;
  int seq = 0;
  char *xseq;
  int s;
  char *doc_root = "";

  /* DB2 library needs the db2 environment */
  s = putenv(DB2_ENV);

  WebTemplate_get_by_name(W, "page", "page.tpl");

  menu_init(W);
  menu_set(W, "SVPEMPAGE");

  /* Get arguments */

  WebTemplate_get_args(W);

  userid = remote_user;
  seqstr = WebTemplate_get_arg(W, "seq");
  if (seqstr) seq = atoi(seqstr);
  req = WebTemplate_get_arg(W, "req");
  xseq = WebTemplate_get_arg(W, "xseq");

  WebTemplate_assign(W, "TITLE",
        "University of Washington Certificate Authority");
  WebTemplate_assign(W, "CURPAGE", "UW Services CA IE keypair generator");
  WebTemplate_assign(W, "XSEQ", xsec_gen_token(userid));
  WebTemplate_assign(W, "ROOT", doc_root);



  /* rest of page depends on request */

  /* xenroll response - request attached */

  if (REQ("iereq")) {

     /* send the xenroll script to make the request */

     FILE *f = fopen("/tmp/ie.out","w");
     char *pk = WebTemplate_get_arg(W,"pkcs");
     if (f) {
        fputs(pk, f);
        fclose(f);
     }
     WebTemplate_assign(W, "BODY", "OK");

  } else if (REQ("ieget")) {

     /* send the signed cert */

     int rc;
     int crtno = 0;
     char *p;
     SvrCert S = (SvrCert) malloc(sizeof(SvrCert_));
     SvrReq R = (SvrReq) malloc(sizeof(SvrReq_));

     menu_set(W, "SVREQPAGE");
     WebTemplate_assign(W, "CA", "UW Services CA");
     WebTemplate_assign(W, "CURPAGE", "View requests");
     WebTemplate_get_by_name(W, "iehead", "iehead.tpl");
     WebTemplate_get_by_name(W, "iebody", "iebody.tpl");
     WebTemplate_get_by_name(W, "ieload", "ieload.tpl");
     p = WebTemplate_get_arg(W, "crt");
     if (p) crtno = atoi(p);

     db_connect();

     db_select_crt(crtno, 0 ,'\0');

     if (db_get_crt(S)>0) {
        db_select_req(S->reqno, NULL, ST_NONE, NULL);
        db_get_req(R);
        WebTemplate_assign(W, "VBCERT", fix_cert_for_vbs(S->cert));
        WebTemplate_assign(W, "CN", R->dn);
     }
     WebTemplate_parse(W, "HEADTXT", "iehead");
     WebTemplate_parse(W, "BODYTXT", "iebody");
     WebTemplate_parse(W, "BODY", "ieload");
   

  } else {

     /* send the request form */
/**
     if (xsec_chk_token(NULL, xseq)) {
        WebTemplate_assign(W, "BODY", 
           "<p>Got a sequence error<p>Should you be here?<p>");
     } else {
 **/

     WebTemplate_get_by_name(W, "iehead", "iehead.tpl");
     WebTemplate_get_by_name(W, "iebody", "iebody.tpl");
     WebTemplate_get_by_name(W, "iereq", "iereq.tpl");

     WebTemplate_parse(W, "HEADTXT", "iehead");
     WebTemplate_parse(W, "BODYTXT", "iebody");
     WebTemplate_parse(W, "BODY", "iereq");
        
   }

   WebTemplate_parse(W, "PAGE", "page");
   WebTemplate_write(W, "PAGE");

   exit (0);

}

